"""
Get to know your classmates better! In these exercises, you will be able to
familiarize yourself with reading and writing to csv files. Files in this
format are common in many fields. We encourage you to use csv.DictReader() and
csv.DictWriter() as introduced in lecture. Don't forget to refer to Monday's
Lecture 12 slide deck and posted code for any refreshers.

Data for the following exercises can be found using cs1_23fa_students.csv.

Credit for original ideas: Megan Santhumayor
"""

import csv

# Use this program constant when processing the student
# dataset in the following exercises
STUDENT_DATASET = 'cs1_23fa_students.csv'


# Exercise 1: Students in CS 1 this year have a wide array of interests and
# intended areas of study. Write a function that returns the percentage of
# students who plan to pursue a given major. Note that some students are
# undecided or would like to double major (ex: 'BioE/CS') so be sure to account
# for that in your function.
# Note that the function should return 0.0 if the file happens to have 0 rows.
def find_preference(major):
    """
    docstring
    """
    # What is the column name for this?
    intended_major_col = 'TODO'
    pass

# Next: Using this function, find and report the percentage of
# students who are interested in the CS major.

# (Optional): Use the function to find the percentage of students who are
# interested in the same area of study as you (if different from CS)


# Exercise 2: Write a function that for all students who are not in their first
# year at Caltech, prints their favorite class so far (one per line). One of
# these courses may become your favorite!
def report_favorite_classes():
    """
    docstring
    """
    header = 'Favorite classes for incoming CS 1 students'
    # Format nicely before printing each favorite class
    print('-' * len(header))

    # What are the column names for these?
    year_col = 'TODO'
    fav_class_col = 'TODO'
    pass


# Exercise 3: Write a function that for all students whose intended major is
# not CS, writes what they are hoping to get from CS 1 this quarter to a
# file called cs1_student_goals.csv with the column name "Student Goals".
# When correctly implemented and ran, you should see a new file
# in this directory with the same number of rows as the original dataset,
# and a single column 'Student Goals'. And make sure the original dataset
# is unchanged!
def save_student_goals():
    """
    docstring
    """
    # (Provided) column name for new file (not the original dataset)
    new_col = 'Student Goals'
    new_file = 'cs1_student_goals.csv'

    # What are the column names for these? Hint: These
    # are the columns that should be used when reading STUDENT_DATASET
    intended_major_col = 'TODO'
    goal_col = 'TODO'
    pass


# Extra practice: What other questions do you have about the CS 1 dataset
# that you could explore using Python and CSV processing? Feel free
# to share ideas on Discord!
